#! /bin/sh
eval '(exit $?0)' && eval 'PERL_BADLANG=x;PATH="$PATH:.";export PERL_BADLANG\
;exec perl -x -S -- "$0" ${1+"$@"};#'if 0;eval 'setenv PERL_BADLANG x\
;setenv PATH "$PATH":.;exec perl -x -S -- "$0" $argv:q;#'.q
#!perl -w
+push@INC,'.';$0=~/(.*)/s;do(index($1,"/")<0?"./$1":$1);die$@if$@__END__+if 0
;#Don't touch/remove lines 1--7: http://www.inf.bme.hu/~pts/Magic.Perl.Header
#
# texref.pl -- display and fix references in LaTeX source files
# by pts@fazekas.hu at Sat Dec 20 11:33:20 CET 2003
#
# LaTeX commands affected: \label{...}, \ref{...}, \pageref{...},
#   \aref{...}, \Aref{...}, \apageref{...}, \Apageref{...}.
# Files affected: *.tex, *.latex
#
# Dat: for \label{...} only ... not containing `{' or `}' is accepted
# Dat: to make fake \label's or \ref's, use \@gobble{\label{ptsvt3-a1}}
# Dat: to make invisible \labels's or \ref's, use \csname label\endcsname{foo}
#
use integer;
use strict;

#** A regexp.
my $VALID_FILENAME='[.](tex|latex)\Z(?!\n)';

# ---

my $do_fixnames=0;
my $verbose=2;

sub debug($) { print STDERR "debug: $_[0]\n" if $verbose>1 }
sub info ($) { print STDERR  "info: $_[0]\n" if $verbose>0 }

#** @param $_[0] sub($filename)
#** @param $_[1] arrayref of dirs and/or files
sub do_recursive($$) {
  my($proc,$fn,$subfn,$ffn)=($_[0]);
  my @list=@{$_[1]};
  for my $fn (@list) { # FIFO (queue) which eats too much memory
    if (!lstat $fn) { print STDERR "$0: missing $fn: $!\n" }
    elsif (-f _) { $proc->($fn) }
    elsif (-d _) {
      if (opendir DR, $fn) {
        while (defined($subfn=readdir DR)) {
          if ($subfn eq '.' or $subfn eq '..') {}
          # vvv Dat: `/' depends on UNIX
          elsif (-f ($ffn="$fn/$subfn")) { $proc->($ffn) } 
          elsif (-d _) { push @list, $ffn }
          else {} # Dat: ignore special inodes
        }
        closedir DR
      } else { print STDERR "$0: opendir $fn: $!\n" }
    } # Dat: ignore special inodes
  }
}

#** Similar to `perl -pi'
#** @param $_[0] filename
#** @param $_[1] sub for each line (acts on $_)
#** @param $_[2] sub that returns what to print at EOF
sub in_place($$;$) {
  # no tempfile here, because we cannot `rename'
  my($FN,$SUB,$SUB2)=@_;
  die "$0: < $FN: $!\n" unless open F, "< $FN";
  die "$0: > $FN.new: $!\n" unless open B, "> $FN.new";
  my $okp=1; # Imp: signal read-error
  while (<F>) { $SUB->(); last unless $okp&&=print B; }
  print B $SUB2->() if $okp and defined $SUB2;
  close F;
  close B;
  unlink $FN;
  if (!$okp) { unlink "$FN.new"; die "$0: error writing: $FN.new\n" }
  if (!rename "$FN.new", $FN) { $_="$0: rename $FN: $!\n"; unlink "$FN.new"; die $_ }
}

# ---

#** Reference severities: target \label of \ref is ...
#** 0: within the same file
#** 1: within the same directory
#** 2: parent++ directory
#** 3: child++ directory
#** 4: different directory
#** 5: target is missing
;

#** Minimum severity eligible for a warning.
my $min_sev=2;

#** The Xpos datatype is: [$filename, $lineno, $lineofs, $posofs,
#**   $expected_label, $ref_count, $subpart_id]
#** $lineno >= 1, $posofs >= $lineofs >= 0.
;

#** $label{'foo'}==$xpos means: \label{foo} is defined at $xpos.
my %label;

#** $label{'foo'}=='bar': \ref{foo} should be changed to \ref{bar}, and also
#** for \labels etc.
my %change;

my $filec;
my $badlabnamec;

#** @param $_[0] Xpos
sub format_xpos($) {
  "$_[0][0]:$_[0][1]:".(1+$_[0][3]-$_[0][2])
}

sub add_labels($) {
  my $fn=$_[0];
  return if $fn!~/$VALID_FILENAME/o;
  my $dir=$fn; $dir=~s@(/?)/*[^/]*\Z(?!\n)@$1@; # Dat: depends on UNIX
  $filec++;
  debug "adding $fn";
  die unless open F, "< $fn";
  my $lineofs=0; my $linec=1; my $xpos; my $labname;
  my $subpart=0;
  while (<F>) {
    s@%(.*)@" "x length$1@e; # remove comments
    $subpart++ while /^\\VT/g; # Imp: intermix \label and \subpart
    while (/(\\label\s*\{([^{}]+)\})/g) {
      $labname=$2;
      $xpos=[$fn,$linec,$lineofs,pos()-length($1)+$lineofs,"",0,$subpart];
      $xpos->[4]=$labname; $xpos->[4]=~s@\A.*/@@; # Dat: depends on UNIX
      $xpos->[4]=$dir.$xpos->[4];
      # Dat: $badlabnamec++ even for multiply-defined labels
      if ($labname=~y@#@@) {
        print STDERR "warning: \\label{$labname} contains macro arg at ".format_xpos($xpos)."\n";
        $change{$labname}=$xpos->[4] if $do_fixnames;
        $badlabnamec++;
      }
      if ($xpos->[4] ne $labname) {
        print STDERR "warning: \\label{$labname} should be \\label{$xpos->[4]}\n";
        $change{$labname}=$xpos->[4] if $do_fixnames;
        $badlabnamec++;
      }
      if (exists $label{$labname}) {
        print STDERR "warning: \\label{$labname} defined again -- keeping ".
          format_xpos($label{$labname})." and ignoring ".format_xpos($xpos)."\n";
      } else { $label{$labname}=$xpos }
    }
    $lineofs+=length; $linec++;
  }
}

my $changedfnc;
sub fix_names($) {
  my $fn=$_[0];
  return if $fn!~/$VALID_FILENAME/o;
  die unless open F, "< $fn";
  my $do_change=0;
  while (<F>) {
    s@%(.*)@" "x length$1@e; # remove comments
    while (/((\\(?:label|[Aa]?(?:page)?ref)\s*)\{([^{}]+)\})/g and exists $change{$3}) {
      $do_change=1;
    }
  }
  close F;
  if ($do_change) {
    debug "changing $fn";
    $changedfnc++;
    in_place $fn, sub {
      s/((\\(?:label|[Aa]?(?:page)?ref)\s*\{)([^{}]+)\})/ # {
        $2.(exists $change{$3} ? $change{$3} : $3).'}'
      /ge
    }
  }
}

my $refcheckedc;
my $refwarningc;
sub check_refs($) {
  my $fn=$_[0];
  my $dir=$fn; $dir='.' if $dir!~s@/[^/]*\Z(?!\n)@@; # Dat: depends on UNIX
  return if $fn!~/$VALID_FILENAME/o;
  debug "checking $fn";
  die unless open F, "< $fn";
  my $lineofs=0; my $linec=1; my($xpos,$txpos,$sev,$tdir);
  my $subpart=0;
  while (<F>) {
    s@%(.*)@" "x length$1@e; # remove comments
    $subpart++ while /^\\VT/g; # Imp: intermix \label and \subpart
    while (/(\\((?:full|[Aa]?(?:page)?)ref)\s*\{([^{}]+)\})/g) {
      $refcheckedc++;
      $xpos=[$fn,$linec,$lineofs,pos()-length($1)+$lineofs];
      if (!exists $label{$3}) {
	if (index($3,'#')>=0) {
	  print STDERR "warning: \\ref{$3} contains macro arg at ".format_xpos($xpos)."\n";
	  $refwarningc++;
	}
        $sev=6; undef $txpos;
      } else {
        $txpos=$label{$3};
	$txpos->[5]++; # ref. count
        $tdir=$txpos->[0]; $tdir=~s@/[^/]*\Z(?!\n)@@; # Dat: depends on UNIX
        ##info "$dir $tdir";
        if ($fn eq $txpos->[0]) { $sev=$txpos->[6] ne $subpart }
        elsif ($dir eq $tdir) { $sev=2 }
        elsif (substr($dir,0,length($tdir)) eq $tdir and substr($dir,length($tdir),1) eq '/') { $sev=3 } # Dat: depends on UNIX
        elsif (substr($tdir,0,length($dir)) eq $dir and substr($tdir,length($dir ),1) eq '/') { $sev=4 } # Dat: depends on UNIX
        else { $sev=5 }
      }
      if ($sev>=$min_sev) {
        $refwarningc++;
           if ($sev==0) { print STDERR "warning: target of \\$2"."{$3} at ".format_xpos($xpos)." is in same file: ".format_xpos($txpos)."\n" }
        elsif ($sev==1) { print STDERR "warning: target of \\$2"."{$3} at ".format_xpos($xpos)." is in other subpart: ".format_xpos($txpos)."\n" }
        elsif ($sev==2) { print STDERR "warning: target of \\$2"."{$3} at ".format_xpos($xpos)." is in same dir: ".format_xpos($txpos)."\n" }
        elsif ($sev==3) { print STDERR "warning: target of \\$2"."{$3} at ".format_xpos($xpos)." is in parent++ dir: ".format_xpos($txpos)."\n" }
        elsif ($sev==4) { print STDERR "warning: target of \\$2"."{$3} at ".format_xpos($xpos)." is in child++ dir: ".format_xpos($txpos)."\n" }
        elsif ($sev==5) { print STDERR "warning: target of \\$2"."{$3} at ".format_xpos($xpos)." is in another dir: ".format_xpos($txpos)."\n" }
        elsif ($sev==6) { print STDERR "warning: missing target for \\$2"."{$3} at ".format_xpos($xpos)."\n" }
        else { die }
      }
    }
    $lineofs+=length; $linec++;
  }
  close F; # reset line counter
}

sub usage() {
  die "This is texref.pl, written by pts\@fazekas.hu in December 2003
Usage: $0 [<option>...] <LaTeX-file>|<dir> ...
Options are:
-v                      increase verbosity (default: 1)
--verbose={0|1|2}       set verbosity
-s                      decrease minimum severity (default: 1)
--min-sev={0|1|2|3|4|5} set minimum severity
-f                      fix ref names (default: don't)\n";
}

# --- main()

$verbose=1;
#$min_sev=0;
$do_fixnames=0; # Imp: report only
{ my $I;
  for ($I=0;$I<@ARGV;$I++) {
       if ($ARGV[$I] eq '--') { $I++; last }
    elsif ($ARGV[$I] eq '-' or substr($ARGV[$I],0,1)ne'-') { last }
    elsif ($ARGV[$I] eq '-v') { $verbose++ }
    elsif ($ARGV[$I] eq '-s') { $min_sev-- }
    elsif ($ARGV[$I] eq '-f') { $do_fixnames++ }
    elsif ($ARGV[$I]=~/\A-+verbose=(\d+)\Z(?!\n)/) { $verbose=$1+0 }
    elsif ($ARGV[$I]=~/\A-+min-sev=(\d+)\Z(?!\n)/) { $min_sev=$1+0 }
  }
  splice @ARGV, 0, $I
}
usage if !@ARGV;

%change=();
%label=(); $filec=0; $badlabnamec=0;
do_recursive \&add_labels, \@ARGV;
info scalar(keys %label)." \\labels and $badlabnamec badly named in $filec files";
if ($do_fixnames and $badlabnamec!=0) {
  $changedfnc=0;
  do_recursive \&fix_names, \@ARGV;
  info "$changedfnc files changed";
  $do_fixnames=0; %change=();
  %label=(); $filec=0; $badlabnamec=0;
  do_recursive \&add_labels, \@ARGV;
}
if (0!=$filec) {
  $refwarningc=0; $refcheckedc=0;
  do_recursive \&check_refs, \@ARGV;
  info "$refwarningc of $refcheckedc refs had problems";
  if ($min_sev>0) {
    my $unrefc=0;
    for my $labname (sort keys %label) {
      next if $label{$labname}[5];
      #my @L=keys%label;
      #print"@L;;\n"; die $label{$labname}[5];
      print STDERR "warning: unreferenced \\label{$label{$labname}[4]} at ".format_xpos($label{$labname})."\n";
      $unrefc++;
    }
    info "$unrefc of ".scalar(keys %label)." labels unreferenced" if $unrefc>0;
  }
}